#!/bin/sh
# 02/10/2004

#TODO:- one build failure, and bails out of testing (getgroups())

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_dc()
{
# CONFIGURE...
	if [ -r ${TCTREE}/opt/freglx/bin/detect-config ] ; then
		# Ah, sanity! 2005-11-11 onward
		PHASE=dc . ${TCTREE}/opt/freglx/bin/detect-config || exit 1
	else
#		echo "$0: CONFIGURE: Configuration not determined" 1>&2
		if [ -d ${TCTREE}/cross-utils ] ; then
			FR_TC_ROOT=${TCTREE}/cross-utils
			FR_TH_ROOT=${TCTREE}/host-utils
		else
			FR_TC_ROOT=${TCTREE}/
			FR_TH_ROOT=${TCTREE}/
		fi

		FR_KERNSRC=${FR_TC_ROOT}/usr/src/linux-2.0.40
		FR_LIBCDIR=${FR_TC_ROOT}/usr/${TARGET_CPU}-linux-uclibc
		if [ -r ${FR_TH_ROOT}/usr/bin/gcc ] ; then
			FR_HOST_CC=${FR_TH_ROOT}/usr/bin/gcc
		else
			FR_HOST_CC=`which gcc`
		fi
		FR_CROSS_CC=${FR_LIBCDIR}/bin/${TARGET_CPU}-uclibc-gcc
	fi

	for F in src/conf-cc src/conf-ld ; do
		[ -r ${F}.OLD ] || mv $F $F.OLD || exit 1
	done

	cat src/conf-cc.OLD \
		| sed 's%^gcc%'${TCTREE}'/usr/'${TARGET_CPU}'-linux-uclibc/bin/'${TARGET_CPU}'-uclibc-gcc%' \
		> src/conf-cc || exit 1

	cat src/conf-ld.OLD \
		| sed 's%^gcc%'${TCTREE}'/usr/'${TARGET_CPU}'-linux-uclibc/bin/'${TARGET_CPU}'-uclibc-gcc%' \
		> src/conf-ld || exit 1

# BUILD...
#	PATH=${FR_LIBCDIR}/bin:${PATH} \
#		make || exit 1
	touch src/home || exit 1
	( cd src &&
		PATH=${FR_LIBCDIR}/bin:${PATH} make || exit 1
	) || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
}

case "$1" in
distro-cross)
	make_dc || exit 1
	;;
#toolchain-host)
#	INSTTEMP=${TCTREE} make_th || exit 1
#	;;
*)
	echo "$0: Unexpected ARG '$1'" 1>&2
	exit 1
	;;
esac
