#!/bin/sh -x
# 2008-02-16 (prev 2007-04-16)

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_dc()
{
# CONFIGURE...
	if [ -r ${TCTREE}/opt/freglx/bin/detect-config ] ; then
		# Ah, sanity! 2005-11-11 onward
		PHASE=dc . ${TCTREE}/opt/freglx/bin/detect-config || exit 1
	else
#		echo "$0: CONFIGURE: Configuration not determined" 1>&2
		if [ -d ${TCTREE}/cross-utils ] ; then
			FR_TC_ROOT=${TCTREE}/cross-utils
			FR_TH_ROOT=${TCTREE}/host-utils
		else
			FR_TC_ROOT=${TCTREE}/
			FR_TH_ROOT=${TCTREE}/
		fi

		FR_KERNSRC=${FR_TC_ROOT}/usr/src/linux-2.0.40
		FR_LIBCDIR=${FR_TC_ROOT}/usr/${TARGET_CPU}-linux-uclibc
		if [ -r ${FR_TH_ROOT}/usr/bin/gcc ] ; then
			FR_HOST_CC=${FR_TH_ROOT}/usr/bin/gcc
		else
			FR_HOST_CC=`which gcc`
		fi
		FR_CROSS_CC=${FR_LIBCDIR}/bin/${TARGET_CPU}-uclibc-gcc
	fi

	case ${PKGVER} in
	0.9.*)
		# requires assertion features.conf exists for cross compilation
		PATH=${FR_LIBCDIR}/bin:${PATH} \
		  ac_cv_file___features_conf=yes \
		  ac_cv_func_setvbuf_reversed=no \
		  CC=${FR_CROSS_CC} \
		  CFLAGS=-O2 \
			./configure --prefix=/usr \
			  --host=`uname -m` --build=${TARGET_CPU} \
			  --disable-nls --disable-largefile \
			  --without-x \
			  `uname -s | tr A-Z a-z` \
			  || exit 1
	;;
	0.10.5|0.10.6|0.11.[23])
		[ -r configure.OLD ] || mv configure configure.OLD || exit 1
		cat configure.OLD \
			| sed 's%^builddir=.*%builddir=.%' \
			| sed 's%^srcdir=.*%srcdir=.%' \
			> configure || exit 1
		chmod a+x configure || exit 1

		# requires assertion features.conf exists for cross compilation
		PATH=${FR_LIBCDIR}/bin:${PATH} \
		  ac_cv_file___features_conf=yes \
		  ac_cv_func_setvbuf_reversed=no \
		  CC=${FR_CROSS_CC} \
		  CFLAGS=-O2 \
			./configure --prefix=/usr \
			  --host=`uname -m` --build=${TARGET_CPU} \
			  --disable-nls --disable-largefile \
			  --without-x \
			  `uname -s | tr A-Z a-z` \
			  || exit 1

		find ./ -name Makefile | while read MF ; do
			[ -r ${MF}.OLD ] || mv ${MF} ${MF}.OLD || exit 1
			cat ${MF}.OLD \
				| sed 's%^AR *= *ar%AR='`echo ${FR_CROSS_CC} | sed 's/gcc$/ar/'`'%' \
				> ${MF} || exit 1
		done

	;;
	0.11.4rc[01])
		# builddir lets us fake features.conf existence
		[ -r configure.OLD ] || mv configure configure.OLD || exit 1
		cat configure.OLD \
			| sed 's%^builddir=.*%builddir=.%' \
			| sed 's%^srcdir=.*%srcdir=.%' \
			> configure || exit 1
		chmod a+x configure || exit 1

		# also need just the CPU in build= to fake native build
		PATH=${FR_LIBCDIR}/bin:${PATH} \
		  ac_cv_file___features_conf=yes \
		  ac_cv_func_setvbuf_reversed=no \
		  CC=${FR_CROSS_CC} \
		  CFLAGS=-O2 \
			./configure --prefix=/usr \
			  --host=`uname -m` --build=${TARGET_CPU} \
			  --disable-nls --disable-largefile \
			  --without-x \
			  `uname -s | tr A-Z a-z` \
			  || exit 1

#		find ./ -name Makefile | while read MF ; do
#			[ -r ${MF}.OLD ] || mv ${MF} ${MF}.OLD || exit 1
#			cat ${MF}.OLD \
#				| sed 's%^AR *= *ar%AR='`echo ${FR_CROSS_CC} | sed 's/gcc$/ar/'`'%' \
#				> ${MF} || exit 1
#		done
#
	;;
	*)	echo "$0: CONFIGURE: Unexpected PKGVER ${PKGVER}" 1>&2
		exit 1
	;;
	esac

# BUILD...
#	PATH=${FR_LIBCDIR}/bin:${PATH}
	make || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
}

case "$1" in
distro-cross)
	make_dc || exit 1
;;
#toolchain-host)
#	INSTTEMP=${TCTREE} make_th || exit 1
#;;
*)
	echo "$0: Unexpected ARG '$1'" 1>&2
	exit 1
;;
esac
