#!/bin/sh
# 11/12/2005

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_dc()
{
# CONFIGURE...
	if [ -r ${TCTREE}/opt/freglx/bin/detect-config ] ; then
		# Ah, sanity! 2005-11-11 onward
		PHASE=dc . ${TCTREE}/opt/freglx/bin/detect-config || exit 1
	else
#		echo "$0: CONFIGURE: Configuration not determined" 1>&2
		if [ -d ${TCTREE}/cross-utils ] ; then
			FR_TC_ROOT=${TCTREE}/cross-utils
			FR_TH_ROOT=${TCTREE}/host-utils
		else
			FR_TC_ROOT=${TCTREE}/
			FR_TH_ROOT=${TCTREE}/
		fi

		FR_KERNSRC=${FR_TC_ROOT}/usr/src/linux-2.0.40
		FR_LIBCDIR=${FR_TC_ROOT}/usr/${TARGET_CPU}-linux-uclibc
		if [ -r ${FR_TH_ROOT}/usr/bin/gcc ] ; then
			FR_HOST_CC=${FR_TH_ROOT}/usr/bin/gcc
		else
			FR_HOST_CC=`which gcc`
		fi
		FR_CROSS_CC=${FR_LIBCDIR}/bin/${TARGET_CPU}-uclibc-gcc
	fi

	if [ -r ${FR_LIBCDIR}/include/ncurses/ncurses.h ] ; then
		# toolchain 0.7.x and later
		ADD_INCL_NCURSES='-I'${FR_LIBCDIR}'/include/ncurses/'
	elif [ -r ${FR_LIBCDIR}/include/ncurses.h ] ; then
		# toolchain 0.6.4 and prior
		ADD_INCL_NCURSES='-I'${FR_LIBCDIR}'/include'
	else
		echo "$0: Confused -- no ncurses.h" 1>&2
		exit 1
	fi

	case ${PKGVER} in
	3.2.7)
		[ -r Makefile.OLD ] || mv Makefile Makefile.OLD || exit 1
		cat Makefile.OLD \
			| sed	' s%$(CC)%'${FR_CROSS_CC}'%
				; /^CPPFLAGS/ s%-I.*%'${ADD_INCL_NCURSES}'%
				' > Makefile || exit 1
## | sed '/^ALL_CPPFLAGS/ s%=%= -nostdinc -I'${FR_LIBCDIR}'/include '${ADD_INCL_NCURSES}' -I'${GCCINCDIR}' -I'${TCTREE}'/usr/include %' \
#	[ -r Makefile.OLD ] || mv Makefile Makefile.OLD || exit 1
#	cat Makefile.OLD \
#		| sed 's%$(CC)%'${FR_CROSS_CC}'%' \
#		| sed '/^CPPFLAGS/ s%=.*%%' \
#		| sed 's%= ldconfig%= %' \
#		| sed 's/--owner 0//' \
#		| sed 's/--group 0//' \
#		> Makefile || exit 1

	# proc/escape.c - fix WCHAR dependency
	[ -r proc/escape.c.OLD ] || mv proc/escape.c proc/escape.c.OLD || exit 1
	cat proc/escape.c.OLD \
		| sed '/#if.*__GNU_LIBRARY__/ s/$/ \&\& !defined(__UCLIBC__)/' \
		> proc/escape.c || exit 1
	;;
	*)	echo "$0: CONFIGURE: Unexpected PKGVER ${PKGVER}" 1>&2
		exit 1
		;;
	esac

# BUILD...
#	PATH=${FR_LIBCDIR}/bin:${PATH} \
#		make CC=${FR_CROSS_CC} \
#		  || exit 1
	make || exit 1

# INSTALL...
#	# v3.2.4 still wants to build stuff...
#	make DESTDIR=${INSTTEMP} \
#		CC=${FR_CROSS_CC} \
#		  install || exit 1
	make DESTDIR=${INSTTEMP} install || exit 1
}

case "$1" in
distro-cross)
	make_dc || exit 1
	;;
#toolchain-host)
#	INSTTEMP=${TCTREE} make_th || exit 1
#	;;
*)
	exit 1
	;;
esac
